import java.net.*;
import java.io.*;

public class ServCliente implements Runnable {
   private Socket cliente;
   private int codigo;
   private DataInputStream in;
   private DataOutputStream out;
   private ServServidor servidor;
   private boolean ativo = true;
   
   public ServCliente(Socket c, int codigo, ServServidor servidor) throws Exception {
      this.cliente = c;
      this.codigo = codigo;
      this.servidor = servidor;
      this.in  = new DataInputStream( c.getInputStream());
      this.out = new DataOutputStream( c.getOutputStream());      
   }

   public void send(String mensagem) {
      if(!this.ativo)
	 return;
      try {
	 out.writeBytes(mensagem);
      } catch(Exception e) {
	 this.ativo = false;
      }
	    
   }

   public void run() {
      while(true) {
	 try {
	    String mes = in.readLine();

	    Mensagem p = Mensagem.stringToMensagem(mes);
	    p.setQuem(this.codigo);
	    this.servidor.novaMensagem(p);
	 } catch(Exception e) {
	    this.ativo = false;
	    return;
	 }
      }
   } 

}
